{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Client:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Employee:{routeName:'Employee-showall',table:'employees',modulename:'Employee'}
            //,Employee:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name'}
            //,JobRotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //Productions:{routeName:'ClientProductionDetail-showall',table:'client_production_details',modulename:'ClientProductionDetail'},
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldDisplay:'name',options:{where:'O',finish:null}}
            //,ProductTreeG:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldDisplay:'name',options:{where:'O',finish:null}}
            //,JobRotationTeam:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            const gridConfig = {
                cm: [
                    {header: "{{ 'TaskRejectDetail.client'|trans }}", dataIndex: 'client',width: 80,filter:'single',alias:'trd',type:'combo',store:t.extras.clients,operator:'='},
                    {header: "{{ 'TaskRejectDetail.day'|trans }}", dataIndex: 'day', width: 70,filter:'between',alias:'trd'},
                    {header: "{{ 'TaskRejectDetail.jobrotation'|trans }}", dataIndex: 'jobrotation', width: 80,filter:'single',type:'combo',store:t.extras.job_rotations,alias:'trd',operator:'='},
                    //{header: "{{ 'TaskRejectDetail.week'|trans }}", dataIndex: 'week', width: 50,filter:'single',alias:'trd',operator:'='},
                    //{header: "{{ 'TaskRejectDetail.jobrotationteam'|trans }}", dataIndex: 'jobrotationteam', width: 140,filter:'single', type:'combo',store:t.stores.JobRotationTeamG,alias:'trd',operator:'='},
                    {header: "{{ 'TaskRejectDetail.employee'|trans }}", dataIndex: 'empname', width: 140,alias:'trd',operator:'='},
                    {header: "{{ 'TaskRejectDetail.opname'|trans }}", dataIndex: 'opname', width: 250,alias:'trd',filter:'single',operator:'%.%'},
                    {header: "{{ 'TaskRejectDetail.time'|trans }}", dataIndex: 'time', width: 120,alias:'trd',filter:'between'},
                    {header: "{{ 'TaskRejectDetail.rejecttype'|trans }}", dataIndex: 'rejecttype', width: 250,alias:'trd',filter:'between'},
                    {header: "{{ 'TaskRejectDetail.quantity'|trans }}", dataIndex: 'quantityreject', width: 60,alias:'trd', align:'right'}
                    //{header: "{{ 'TaskRejectDetail.ismandatory'|trans }}", dataIndex: 'ismandatory', width: 50,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'cpd'},
                    //{header: "{{ 'TaskRejectDetail.isrework'|trans }}", dataIndex: 'isrework', width: 50,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'cpd'}
                   // {header: "{{ 'TaskRejectDetail.issystem'|trans }}", dataIndex: 'issystem', width: 50,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'cpd'}
                ]
                ,pbar : new mj.pager({defaultButtons:true,elements: {first:true,prev:true,pages:true,next:true,last:true,selectLimit:true,refresh:false}, limit:10})
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 220,
                        height : 280,
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.combo({
                                title: "{{ 'TaskRejectDetail.client'|trans }}",
                                placeHolder: "{{ 'TaskRejectDetail.client_placeholder'|trans }}",
                                dataIndex: 'client',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '70px',
                                grid: 's6 m4',
                                store: t.extras.clients,
                                width:130
                            }),
                            new mj.form.dateField({
                                title: "{{ 'TaskRejectDetail.day'|trans }}",
                                dataIndex: 'day',
                                labelWidth : '70px',
                                notEmpty: true,
                                width:80,
                                grid: 's4 m2'
                            }),
                            new mj.form.combo({
                                title: "{{ 'TaskRejectDetail.jobrotation'|trans }}",
                                placeHolder: "{{ 'TaskRejectDetail.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '70px',
                                grid: 's6 m4',
                                store: t.extras.job_rotations,
                                width:130
                            }),
                            new mj.form.dateField({
                                title: "{{ 'TaskRejectDetail.time'|trans }}",
                                dataIndex: 'time_d',
                                labelWidth : '70px',
                                notEmpty: true,
                                width:80,
                                //maxLength: 19,
                                grid: 's4 m2'
                            }),
                            new mj.form.timeField2({
                                title: "",
                                dataIndex: 'time_t',
                                notEmpty: true,
                                labelWidth : '10px',
                                grid: 's12 m6',
                                width:50,
                                right:true
                            })
                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : "{{ 'TaskRejectDetail.opnames'|trans }}",
                        labelWidth : '110px',
                        width : 750,
                        height : 280,
                        style : 'position:absolute;top:0px;left:260px;',
                        items : [

                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f3',
                        title : "{{ 'TaskRejectDetail.rejects'|trans }}",
                        labelWidth : '110px',
                        width : 750,
                        height : 320,
                        style : 'position:absolute;top:300px;left:260px;',
                        items : [

                        ]
                    })
                ]
            };
            t._setFormConfig(formConfig);
            t.cmb_vardiya=t.forms.main.items[7];
            t.zaman=t.forms.main.items[9];

            // t.stores.Productions.on('load',function(st){
            //     // t.clearProductions();
            //     t.grids.productions.store.data=st.data;
            //     t.grids.productions.load();
            // },t);

            t.cmb_vardiya.on('triggerclick',function(){
                t.forms.main.items[8].setValue('');
                t.forms.main.items[9].setValue('');
            });

            t.cmb_vardiya.view.on('itemclick',function(){
                t.clearProductions();
                var data = t.forms.main.getValue();
                if(data.client==null||data.client==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundclient'|trans }}");
                    return;
                }
                if(data.day==null||data.day==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundday'|trans }}");
                    return;
                }
                if(data.jobrotation==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundjobrotation'|trans }}");
                    return;
                }
                //if(data.time_d==null||data.time_t==''){
                //    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundtime'|trans }}");
                //    return;
                //}
                var val=el.value;
                var routeName='TaskRejectDetail-getallrecords-production';
                var route = Routing.getRoute(routeName);
                var data = {
                    'menuId': t.id,
                    'pg': 1,
                    'lm': 10000,
                    'filters' : [
                        {alias:"cpd",fieldname:"client",operator:"=",value:data.client}
                        ,{alias:"cpd",fieldname:"day",operator:"=",value:data.day}
                        ,{alias:"cpd",fieldname:"jobrotation",operator:"=",value:data.jobrotation}
                    ]
                };
                //t.stores.Productions.url=Routing.generate(routeName, data);
                //t.stores.Productions.load();
                t.waitMaskShow();
                $.ajax({
                    url: Routing.generate(routeName, data),
                    method: "POST",
                    data: JSON.stringify(data),
                    dataType: 'json',
                    headers: { 
                        "Content-Type": "application/json",
                        "X-HTTP-Method-Override": route.methods[0] 
                    },
                    success: function(data, textStatus, xhr) {
                        //t.reset(_f, data);
                        t.waitMaskHide();
                        //console.log(data);
                        t.grids.productions.store.data=data.records;
                        t.grids.productions.load();
                    },
                    error: function(xhr, textStatus, errorThrown) {
                        t.waitMaskHide();
                        if(xhr.responseJSON&&xhr.responseJSON.message){
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: xhr.responseJSON.message,
                                type: "error",
                                html: true
                            });
                        }
                    },
                    complete: function(jqXHR, textStatus) {
                        //t.waitMaskHide();
                    }
                });
            });

            var cnt_productions_grid=mj.NE(t.forms.main.items[1].innerEl, {style:'position:absolute;border:1px solid #AFB5AB;left:10px;top:20px;right:10px;bottom:10px;'});
            t.grids.productions = new mj.grid({
                renderTo : cnt_productions_grid,
                store : [],
                pbar : new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent : true,
                sortable : false,
                cm : [
                    {header: "{{ 'TaskRejectDetail.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 70},
                    {header: "{{ 'TaskRejectDetail.opname'|trans }}", dataIndex: 'opname', width: 250},
                    {header: "{{ 'TaskRejectDetail.employee'|trans }}", dataIndex: 'empname', width: 160},
                    {header: "{{ 'TaskRejectDetail.start'|trans }}", dataIndex: 'start', width: 120},
                    {header: "{{ 'TaskRejectDetail.finish'|trans }}", dataIndex: 'finish', width: 120},
                    {header: '', width: 1, hide : true}
                ]
            });
            t.grids.productions.on('rowclick',function(g,s){
                var selectedRecord = t.getSelectedRecord();
                if (selectedRecord === false){
                    t.clearRejects();
                    t.buttons.addBtnrejects.setEnable();
                }
            },t.grids.productions);
            //t.grids.productions.pbar.on('sourceload',function(){
            //    console.log('sourceload');
            //},t.grids.productions);
            t.grids.productions.store.on('load',function(){
                t.clearRejects();
            },t.grids.productions);

            var cnt_rejects_grid=mj.NE(t.forms.main.items[2].innerEl, {style:'position:absolute;border:1px solid #AFB5AB;left:10px;top:20px;right:10px;bottom:10px;'});
            t.grids.rejects = new mj.grid({
                renderTo : cnt_rejects_grid,
                store : [],
                pbar : new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent : true,
                sortable : false,
                cm : [
                    {header: "{{ 'TaskRejectDetail.rejecttype'|trans }}", dataIndex: 'rejecttype', width: 400},
                    {header: "{{ 'TaskRejectDetail.quantity'|trans }}", dataIndex: 'quantity', width: 100},
                    {header: "{{ 'TaskRejectDetail.description'|trans }}", dataIndex: 'description', width: 150},
                    {header: '', width: 1, hide : true}
                ]
            });
            t.buttons.addBtnrejects = t.grids.rejects.pbar.tbar.addButton({id:'btnAddTable',alt:mj.lng.glb.add, iconCls : 'mj-add', handler : t.addrejects,scope:t});
            t.buttons.editBtnrejects = t.grids.rejects.pbar.tbar.addButton({id:'btnEditTable',alt:mj.lng.glb.edit,iconCls :'mj-edit', disabled:true, handler:t.editrejects,scope:t});
            t.buttons.deleteBtnrejects = t.grids.rejects.pbar.tbar.addButton({id:'btnDeleteTable',alt:mj.lng.glb.del, iconCls : 'mj-delete', disabled: true, handler:t.deleterejects,scope:t});
            t.grids.rejects.on('rowclick',function(g,s){
                var selectedRecord = t.getSelectedRecord();
                if (selectedRecord === false){
                    t.buttons.deleteBtnrejects.setEnable();
                }
                t.buttons.editBtnrejects.setEnable();
            },t.grids.rejects);
            t.grids.rejects.on('rowdblclick',function(g,s){
                this.handler.call(this.scope);
            },t.buttons.editBtnrejects);
            t.grids.rejects.pbar.on('sourceload',function(){
                if(typeof t.grids.productions.selectedRow.index==='undefined'){
                    t.buttons.addBtnrejects.setDisable();
                }else{
                    t.buttons.addBtnrejects.setEnable();
                }
                t.buttons.editBtnrejects.setDisable();
                t.buttons.deleteBtnrejects.setDisable();
            },t.grids.rejects);
            t.grids.rejects.store.on('load',function(){
                if(typeof t.grids.productions.selectedRow.index==='undefined'){
                    t.buttons.addBtnrejects.setDisable();
                }else{
                    var selectedRecord = t.getSelectedRecord();
                    if (selectedRecord === false){
                        t.buttons.addBtnrejects.setEnable();
                    }
                }
                t.buttons.editBtnrejects.setDisable();
                t.buttons.deleteBtnrejects.setDisable();
            },t.grids.rejects);
            t.winAddrejects = new mj.window({
                renderTo : mj.NE(),
                title : "{{ 'TaskRejectDetail.employees'|trans }}",
                modal : true,
                width : 400,
                height : 200,
                minWidth : 400,
                minHeight : 200,
                buttons : [
                    {alt: mj.lng.glb.exit,iconCls: 'mj-menu-exit-icon', handler:function(){t.winAddrejects.hide();}},
                    {alt: mj.lng.glb.save,iconCls: 'mj-save', handler:function(){
                        //var d =  t.forms.rejects.items[0].view.selected[0];
                        var dfr=t.forms.rejects.getValue();
                        var data={rejecttype:dfr.rejecttype,quantity:dfr.quantity,description:dfr.description};
                        var g=t.grids.rejects;
                        if(t.rejectsMode=='add'){
                            g.store.data.push(data);
                        }else{
                            g.store.data[g.selectedRow.index] = data;
                        }
                        g.load();
                        t.winAddrejects.hide();
                    }}
                ]
            });
            t.win.addRelated(t.winAddrejects);
            t.forms.rejects = new mj.form({
                renderTo : t.winAddrejects.getBody(),
                store : new mj.store({}),
                buttonPos:false,
                items: [
                    new mj.form.combo({
                        title: "{{ 'TaskRejectDetail.rejecttype'|trans }}",
                        placeHolder: "{{ 'TaskRejectDetail.rejecttype_placeholder'|trans }}",
                        dataIndex: 'rejecttype',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        sameValueDisplay:true,
                        labelWidth : '80px',
                        grid: 's6 m4',
                        width:250,
                        store: t.extras.rejects
                    }),
                    new mj.form.numberField({ 
                        title: "{{ 'TaskRejectDetail.quantity'|trans }}",
                        dataIndex: 'quantity',
                        maxLength: 5,
                        labelWidth : '80px',
                        notEmpty: true,
                        width:60,
                        grid: 's12 m6'
                    }),
                    new mj.form.textArea({
                        title : "{{ 'TaskRejectDetail.description'|trans }}",
                        dataIndex : 'description',
                        labelWidth : '80px',
                        width:250,
                        height:60,
                        maxLength: 255
                    })
                ]
            });
        },
        addrejects : function(){
            var t=this;
            t.forms.rejects.clear();
            t.rejectsMode='add';
            t.winAddrejects.show();
        },
        editrejects : function(){
            var t = this;
            t.rejectsMode='edit';
            t.forms.rejects.store.data = t.grids.rejects.selectedRow.data;
            t.forms.rejects.load();
            t.winAddrejects.show();
        },
        deleterejects : function(){
            var t = this;
            var g=t.grids.rejects;
            new mj.message({
                title:mj.lng.glb.onay,
                modal : true,
                msg:mj.lng.glb.delQuestion,
                buttons:['NO','YES'],
                cb:function(el,btn){
                    if(btn=='YES'){
                        g.store.data.remove(g.store.data[g.selectedRow.index]);
                        g.load();
                    }
                    el.window.close();
                }
            });
        },
        _onButtonAddClick : function(){
            var t=this
            t.newRecord();
            t.clearProductions();
            //t.clearRejects();
        },
        editSelectedRecord: function() {
            var t=this
            t.clearProductions();
            //t.clearRejects();
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false)
                t.editData(selectedRecord);
            //console.log(selectedRecord);
            if(selectedRecord.opnames){
                var productions=selectedRecord.opnames.split('|');
                var tmp=[];
                for(var i=0;i<productions.length;i++){
                    var item=productions[i].split('~');
                    if(tmp.indexOf(item[1])==-1){
                        tmp.push(item[1]);
                        t.grids.productions.store.data.push({erprefnumber:item[0],opname:item[1],empname:item[2],start:item[3],finish:item[4]});
                    }
                }
                t.grids.productions.load();
            }
            t.grids.productions.selectRow(null,0,null);
            if(selectedRecord.rejects){
                var rejects=selectedRecord.rejects.split('|');
                var tmp=[];
                for(var i=0;i<rejects.length;i++){
                    var item=rejects[i].split('~');
                    if(tmp.indexOf(item[1])==-1){
                        tmp.push(item[1]);
                        t.grids.rejects.store.data.push({rejecttype:item[0],quantity:item[1],description:item[2]});
                    }
                }
                t.grids.rejects.load();
            }
        },
        clearProductions : function(){
            var t=this;
            t.grids.productions.store.data=[];
            t.grids.productions.load();
        },
        clearRejects : function(){
            var t=this;
            t.grids.rejects.store.data=[];
            t.grids.rejects.load();
        },
        deleteRecord: function() {
            var t = this,
                _f = this.forms;
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false) {
                mj.message({
                    title: mj.lng.glb.winTitleOnay,
                    modal : true,
                    msg: mj.lng.glb.delQuestion,
                    buttons:['NO','YES'],
                    cb:function(el,btn){
                        if(btn=='YES'){
                            var id = selectedRecord.id;
                            //var version = selectedRecord.version;
                            var routeName = t.modulename + '-del';
                            var route = Routing.getRoute(routeName);
                            var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                                'pg': t.grids.main.pbar.current,
                                'lm': t.grids.main.pbar.limit
                            } : {};
                            var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                                'id': id
                                //,'v': version
                            }) : pagerParams);
                            if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                                t.waitMaskShow();
                                t._event='delete';
                                var data = {'menuId': t.id,record:selectedRecord};
                                $.ajax({
                                    url: url,
                                    method: "POST",
                                    headers: { 
                                        "Content-Type": "application/json",
                                        "X-HTTP-Method-Override": route.methods[0] 
                                    },
                                    dataType: 'json',
                                    data: JSON.stringify(data),
                                    success: function(data, textStatus, jqXHR) {
                                        t.reset(_f, data);
                                    },
                                    error: function(jqXHR, textStatus, errorThrown) {
                                        t.waitMaskHide();
                                        mj.message({
                                            title: mj.lng.glb.error,
                                            msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                            type: "error",
                                            html: true
                                        });
                                    },
                                    complete: function(jqXHR, textStatus) {
                                        //t.waitMaskHide();
                                    }
                                });
                            }
                        }
                        el.window.close();
                    }
                });
            }
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            delete f.cachedItems['rejects'];
            if (f.modulename && typeof Routing !== 'undefined') {
                var selectedRecord = t.getSelectedRecord();
                if (selectedRecord !== false){
                    t.editData(selectedRecord);
                }
                var data = f.getValue();
                if(data.client==null||data.client==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundclient'|trans }}");
                    return;
                }
                if(data.day==null||data.day==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundday'|trans }}");
                    return;
                }
                if(data.jobrotation==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundjobrotation'|trans }}");
                    return;
                }
                if(data.time_d==null||data.time_t==''){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundtime'|trans }}");
                    return;
                }
                if(t.grids.rejects.store.data.length==0){
                    t.messageShow(t,mj.lng.glb.error,"{{ 'TaskRejectDetail.errnotfoundrejects'|trans }}");
                    return;
                }
                var id = data.id;
                var versionField = f.getField('version');
                var version = typeof versionField != "undefined" ? data.version : 0;
                var mode = id ? 'update' : 'add';
                var routeName = f.modulename + '-' + mode;
                var route = Routing.getRoute(routeName);
                var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                    'pg': t.grids.main.pbar.current,
                    'lm': t.grids.main.pbar.limit
                } : {};
                var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                    'id': id,
                    'v': version
                }) : pagerParams);
                
                data.menuId = t.id;
                data.production=t.grids.productions.selectedRow.data;
                data.rejects=t.grids.rejects.store.data;
                if(mode==='update'){
                    data.rejectsold=[];
                    if(selectedRecord.rejects){
                        var rejects=selectedRecord.rejects.split('|');
                        var tmp=[];
                        for(var i=0;i<rejects.length;i++){
                            var item=rejects[i].split('~');
                            if(tmp.indexOf(item[1])==-1){
                                tmp.push(item[1]);
                                data.rejectsold.push({rejecttype:item[0],quantity:item[1],description:item[2]});
                            }
                        }
                    }
                }
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    t.waitMaskShow();
                    t._event='save';
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        data: JSON.stringify(data),
                        dataType: 'json',
                        success: function(data, textStatus, jqXHR) {
                            t.reset(_f, data);
                            //t.activateTabGrid();
                            //t.waitMaskHide();
                        },
                        error: function(jqXHR, textStatus, errorThrown) {
                            t.waitMaskHide();
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                type: "error",
                                html: true
                            });
                        },
                        complete: function(jqXHR, textStatus) {
                            //t.waitMaskHide();
                        }
                    });
                }
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
